/*
 * ViewFunctionMin.java
 *
 * Created on 13. nor 2006, 10:27
 *
 */

package savi.alg.funcmin;

import java.awt.*;
import savi.alg.*;
import savi.alg.SimAnnealingSkeleton;
import savi.visualization.support.VisualizationPanel;
/**
 * Visualization panel class for Finding global minimum problem
 * @author Premysl JIRIK
 */
public class ViewFunctionMin extends VisualizationPanel {
    /**
     * Basic contructor
     */
    public ViewFunctionMin() {
    }
    /**
     * Constructor for state initializing.
     * @param s state
     */
    public ViewFunctionMin(StateSkeleton s) {
        setState(s);
    }
    /**
     * Updates scene (repaints graph).
     */
    public void updateScene() {
        repaint();
    }
    /**
     * Paints this canvas.
     * @param g the specified Graphics context
     */
    public void paint(Graphics g) {
        StateFunction sf = (StateFunction)state;
        
        g.setColor(Color.WHITE);
        g.fillRect(0, 0, 420, 445);
        g.setColor(Color.RED);
        int half = 420 / 2;
        int hght = 445;
        int basey = 500;
        int py = (int)sf.fce(-half);
        for (int i = -half; i < half; i++) {
            int y = (int)sf.fce(i);
            g.drawLine(half + i-1, basey - py, half + i, basey - y); 
            py = y;
        }
        
        g.setColor(Color.BLUE);
        int x = half + (int)sf.getCurrentX();
        int y = basey - (int)sf.getActualCost();
        g.fillOval(x - 3, y - 3,  6,  6);
    }
}
