/*
 * IntegerReader.java
 *
 * Created on 3. erven 2006, 15:02
 *
 */

package savi.alg.sat3;

import java.io.IOException;
import java.io.InputStream;
import java.io.Reader;

/**
 * Read integers from a character-input stream.
 * @author Premysl JIRIK
 */
public class IntegerReader {
    Reader inp;
    /**
     * Creates a new instance of IntegerReader
     * @param r reader
     */
    public IntegerReader(Reader r) {
        inp = r;
    }
    /**
     * Read one integer from stream.
     * @throws java.io.IOException If an I/O error occurs
     * @return integer
     */
    public int readInt() throws IOException {
        int ch = inp.read();
        String s = "";
        while ((ch != '+') && (ch != '-') && ((ch > '9') || (ch < '0')) && (ch != -1))
            ch = inp.read();
        
        if (ch == -1)
            return 0;
        
        s = s + (char)ch;
        ch = inp.read();
        while ((ch <= '9') && (ch >= '0')) {
            s = s + (char)ch;
            ch = inp.read();
        }
         return Integer.parseInt(s);
    }
}
