/*
 * SaviMessageBox.java
 *
 * Created on 25. srpen 2006, 11:31
 *
 */

package savi.dialogs;

import java.awt.*;
import java.awt.event.*;

/**
 * Class for making information dialogs.
 * @author Premysl JIRIK
 */
public class SaviMessageBox extends SaviDialogSkeleton implements ActionListener {
    Button ok;
    Label msg;
    
    /**
     * Creates a new instance of SaviMessageBox; initialize caption, message and 
     * eventualy show dialog
     * @param caption dialog caption
     * @param message text message
     * @param show show dialog if <CODE>true</CODE>
     */
    public SaviMessageBox(String caption, String message, boolean show) {
        super(caption);
        prepareComponents(message);
        if (show)
            showForm();
    }
    /**
     * Creates a new instance of SaviMessageBox; initialize caption, message and 
     * show dialog
     * @param caption dialog caption
     * @param message text message
     */
    public SaviMessageBox(String caption, String message) {
        super(caption);
        prepareComponents(message);
        showForm();
    }
    
    private void prepareComponents(String message) {
        setLayout(new BorderLayout(5, 10));
        add(msg = new Label(message), BorderLayout.NORTH);
        Panel p = new Panel();
        p.add(ok = new Button("OK"), BorderLayout.CENTER);
        add(p, BorderLayout.SOUTH);
        ok.addActionListener(this);
    }
    
    /**
     * Show dialog to user.
     */
    public void showForm() {
        distributeKeyListeners();
        validate();
        pack();
        Dimension d = getToolkit().getScreenSize();
        setLocation((d.width - getWidth())/2, (d.height - getHeight())/2);
        setVisible(true);
    }
    
    /**
     * Handles the actionPerformed event - "close" or "ok".
     * @param ae the action event
     */
    public void actionPerformed(ActionEvent ae) {
        if(ae.getSource() == ok) {
            setVisible(false);
        }
    }    
}
