package savi.visualization;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.ArrayList;
import savi.visualization.addons.*;
import savi.visualization.support.TaskPanel;

/**
 * Base applet class.
 * @author Premysl JIRIK
 */
public class SimAnnealingApplet extends Applet {
//    Graphics    gfx;
    Choice      taskChooser;
    ArrayList   tasks;
    Button      choiceAccept;
    Component   inner;
    private static Applet appletThis = null;
    
    
    /**
     * Creates a new instance of SimAnnealingApplet.
     */
    public SimAnnealingApplet() {
        tasks = new ArrayList();
        appletThis = this;
    }
    
    /**
     * Return applet instance or null, static method -> can be called whenever.
     * @return applet instance or null
     */
    public static Applet getAppletInstance() {
        return appletThis;
    }
    
    /**
     * Called by the browser or applet viewer to inform this applet that it has been loaded into the system.
     */
    public void init() {
//        gfx = getGraphics();
        jbInit();
    }
    //Component initialization
    private void jbInit() {
        setLayout(null);
        setBackground(Color.darkGray);
//        setForeground(Color.white);
        
        taskChooser = new Choice();
        add(taskChooser);
        addVisualization("savi.visualization.addons.Intro");
        addVisualization("savi.visualization.addons.Knapsack");
        addVisualization("savi.visualization.addons.TSP");
        addVisualization("savi.visualization.addons.FunctionMin");
        addVisualization("savi.visualization.addons.MaxSAT3");
        addVisualization("savi.visualization.addons.WeightedSAT3");

        taskChooser.setBounds(5, 5, getWidth() - 15 - 50, 21);
        taskChooser.setBackground(Color.white);
        taskChooser.setForeground(Color.black);
        taskChooser.setVisible(true);
        
        choiceAccept = new Button("Load");
        add(choiceAccept);
        choiceAccept.setBounds(getWidth() - 5 - 50, 5, 50, 21);
        choiceAccept.addActionListener(new ChooseAccept_ActListener(this));
        choiceAccept.setBackground(Color.lightGray);
        choiceAccept.setForeground(Color.black);
        choiceAccept.setVisible(true);
        
        inner = new Intro();
//        inner = this.getClass().getClassLoader().loadClass("").newInstance();
        
        add(inner);
        inner.setBounds(5, 30, getWidth() - 10, getHeight() - 35);
        inner.validate();
        inner.doLayout();
        inner.setVisible(true);
    }
    
    /**
     * Adds new visualization.
     * @param classPath class path
     */
    public void addVisualization(String classPath) {
        try {
            TaskPanel spClass = (TaskPanel)(this.getClass().getClassLoader().loadClass(classPath).newInstance());
            taskChooser.add(spClass.getSimulationName());
            tasks.add(spClass);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
   
    /**
     * Called when user wants load new visualization.
     * @param e the action event
     */
    public void clickChooseAccept(ActionEvent e) {
//        remove(inner);
//        String name = taskChooser.getSelectedItem();
        int idx = taskChooser.getSelectedIndex();
        remove(inner);
        inner = (Component)tasks.get(idx);
        inner.setBounds(5, 30, getWidth() - 10, getHeight() - 35);
        add(inner);
        inner.validate();
        inner.doLayout();
        inner.setVisible(true);
        inner.repaint();
        
/*        try {
            inner = (Container)(this.getClass().getClassLoader().loadClass(name).
                    newInstance());
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        inner.setBounds(5, 30, getWidth() - 10, getHeight() - 35);
        add(inner);
        inner.validate();
        inner.doLayout();
        inner.setVisible(true);
        inner.repaint();
  */  }
    
    /**
     * Informs the result that a test will be started.
     */
    public void start() {
    }
}

class ChooseAccept_ActListener implements ActionListener {
    SimAnnealingApplet adaptee;
    
    ChooseAccept_ActListener(SimAnnealingApplet adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.clickChooseAccept(e);
    }
}
